import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars

import Hidden from '@material-ui/core/Hidden';
import { ReactWidgetModel } from './ReactWidget';
export class HiddenModel extends ReactWidgetModel {
  defaults() {
    return { ...super.defaults(),
      ...{
        _model_name: 'HiddenModel',
        children: undefined,
        class_name: null,
        implementation: undefined,
        initial_width: undefined,
        lg_down: null,
        lg_up: null,
        md_down: null,
        md_up: null,
        only: undefined,
        sm_down: null,
        sm_up: null,
        xl_down: null,
        xl_up: null,
        xs_down: null,
        xs_up: null
      }
    };
  }

  getReactComponent() {
    // eslint-disable-line class-methods-use-this
    return Hidden;
  }

}
HiddenModel.serializers = { ...ReactWidgetModel.serializers,
  children: {
    deserialize: unpack_models
  },
  implementation: {
    deserialize: unpack_models
  },
  initial_width: {
    deserialize: unpack_models
  },
  only: {
    deserialize: unpack_models
  }
};