// This is a specific 'fix' for the notebook only, since its fontsize is non-16
import React from 'react';
import PropTypes from 'prop-types';
import { MuiThemeProvider, createMuiTheme } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
const theme = createMuiTheme({
  typography: {
    // Tell Material-UI what the font-size on the html element is.
    htmlFontSize: 10,
    useNextVariants: true
  }
});

function FontSizeTheme({
  children
}) {
  return React.createElement(MuiThemeProvider, {
    theme: theme
  }, React.createElement(Typography, {
    component: "span"
  }, children));
}

FontSizeTheme.propTypes = {
  children: PropTypes.node.isRequired
};
export function styleWrapper(element) {
  return React.createElement(FontSizeTheme, null, element);
}