import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Badge from '@material-ui/core/Badge';
import { ReactWidgetModel } from './ReactWidget';

export class BadgeModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'BadgeModel',
                badge_content: undefined,
                children: undefined,
                classes: null,
                class_name: null,
                color: undefined,
                component: null,
                invisible: null,
                max: null,
                show_zero: null,
                variant: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Badge;
    }
}

BadgeModel.serializers = {
    ...ReactWidgetModel.serializers,
    badge_content: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
    color: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
};
