import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Checkbox from '@material-ui/core/Checkbox';
import { ReactWidgetModel } from './ReactWidget';

export class CheckboxModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'CheckboxModel',
                checked: null,
                checked_icon: undefined,
                classes: null,
                color: undefined,
                disabled: null,
                disable_ripple: null,
                icon: undefined,
                id: null,
                indeterminate: null,
                indeterminate_icon: undefined,
                input_props: null,
                input_ref: null,
                type: null,
                value: undefined,
                children: undefined,
                class_name: null,
                disable_focus_ripple: null,
                edge: undefined,
                size: undefined,
                action: null,
                button_ref: null,
                center_ripple: null,
                component: null,
                disable_touch_ripple: null,
                focus_ripple: null,
                focus_visible_class_name: null,
                role: null,
                tab_index: null,
                Touch_ripple_props: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Checkbox;
    }
}

CheckboxModel.serializers = {
    ...ReactWidgetModel.serializers,
    checked_icon: { deserialize: unpack_models },
    color: { deserialize: unpack_models },
    icon: { deserialize: unpack_models },
    indeterminate_icon: { deserialize: unpack_models },
    value: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
    edge: { deserialize: unpack_models },
    size: { deserialize: unpack_models },
    component: { deserialize: unpack_models },
};
