import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Chip from '@material-ui/core/Chip';
import { ReactWidgetModel } from './ReactWidget';

export class ChipModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'ChipModel',
                avatar: undefined,
                classes: null,
                class_name: null,
                clickable: null,
                color: undefined,
                component: null,
                delete_icon: undefined,
                icon: undefined,
                label: undefined,
                size: undefined,
                variant: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Chip;
    }
}

ChipModel.serializers = {
    ...ReactWidgetModel.serializers,
    avatar: { deserialize: unpack_models },
    color: { deserialize: unpack_models },
    delete_icon: { deserialize: unpack_models },
    icon: { deserialize: unpack_models },
    label: { deserialize: unpack_models },
    size: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
};
