import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import FilledInput from '@material-ui/core/FilledInput';
import { ReactWidgetModel } from './ReactWidget';

export class FilledInputModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'FilledInputModel',
                auto_complete: null,
                auto_focus: null,
                classes: null,
                class_name: null,
                default_value: undefined,
                disabled: null,
                disable_underline: null,
                end_adornment: undefined,
                error: null,
                full_width: null,
                id: null,
                input_component: null,
                input_props: null,
                input_ref: null,
                margin: undefined,
                multiline: null,
                name: null,
                placeholder: null,
                read_only: null,
                required: null,
                rows: null,
                rows_max: null,
                start_adornment: undefined,
                type: null,
                value: undefined,
                aria_describedby: null,
                select: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return FilledInput;
    }
}

FilledInputModel.serializers = {
    ...ReactWidgetModel.serializers,
    default_value: { deserialize: unpack_models },
    end_adornment: { deserialize: unpack_models },
    margin: { deserialize: unpack_models },
    start_adornment: { deserialize: unpack_models },
    value: { deserialize: unpack_models },
};
