import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import GridList from '@material-ui/core/GridList';
import { ReactWidgetModel } from './ReactWidget';

export class GridListModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'GridListModel',
                cell_height: null,
                children: undefined,
                classes: null,
                class_name: null,
                cols: null,
                component: null,
                spacing: null,
                style: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return GridList;
    }
}

GridListModel.serializers = {
    ...ReactWidgetModel.serializers,
    cell_height: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
};
