import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import GridListTileBar from '@material-ui/core/GridListTileBar';
import { ReactWidgetModel } from './ReactWidget';

export class GridListTileBarModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'GridListTileBarModel',
                action_icon: undefined,
                action_position: undefined,
                classes: null,
                class_name: null,
                subtitle: undefined,
                title: undefined,
                title_position: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return GridListTileBar;
    }
}

GridListTileBarModel.serializers = {
    ...ReactWidgetModel.serializers,
    action_icon: { deserialize: unpack_models },
    action_position: { deserialize: unpack_models },
    subtitle: { deserialize: unpack_models },
    title: { deserialize: unpack_models },
    title_position: { deserialize: unpack_models },
};
