import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import NoSsr from '@material-ui/core/NoSsr';
import { ReactWidgetModel } from './ReactWidget';

export class NoSsrModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'NoSsrModel',
                children: undefined,
                defer: null,
                fallback: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return NoSsr;
    }
}

NoSsrModel.serializers = {
    ...ReactWidgetModel.serializers,
    children: { deserialize: unpack_models },
    fallback: { deserialize: unpack_models },
};
