import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Popper from '@material-ui/core/Popper';
import { ReactWidgetModel } from './ReactWidget';

export class PopperModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'PopperModel',
                anchor_el: null,
                children: undefined,
                container: null,
                disable_portal: null,
                keep_mounted: null,
                modifiers: null,
                open_: null,
                placement: undefined,
                popper_options: null,
                popper_ref: null,
                transition: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Popper;
    }
}

PopperModel.serializers = {
    ...ReactWidgetModel.serializers,
    anchor_el: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
    placement: { deserialize: unpack_models },
};
