import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Stepper from '@material-ui/core/Stepper';
import { ReactWidgetModel } from './ReactWidget';

export class StepperModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'StepperModel',
                active_step: null,
                alternative_label: null,
                children: undefined,
                classes: null,
                class_name: null,
                connector: undefined,
                non_linear: null,
                orientation: undefined,
                component: null,
                elevation: null,
                square: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Stepper;
    }
}

StepperModel.serializers = {
    ...ReactWidgetModel.serializers,
    children: { deserialize: unpack_models },
    connector: { deserialize: unpack_models },
    orientation: { deserialize: unpack_models },
};
