import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import SwipeableDrawer from '@material-ui/core/SwipeableDrawer';
import { ReactWidgetModel } from './ReactWidget';

export class SwipeableDrawerModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'SwipeableDrawerModel',
                anchor: undefined,
                disable_backdrop_transition: null,
                disable_discovery: null,
                disable_swipe_to_open: null,
                hide_backdrop: null,
                hysteresis: null,
                min_fling_velocity: null,
                Modal_props: null,
                open_: null,
                Paper_props: null,
                Swipe_area_props: null,
                swipe_area_width: null,
                transition_duration: null,
                variant: undefined,
                Backdrop_props: null,
                children: undefined,
                classes: null,
                class_name: null,
                elevation: null,
                Slide_props: null,
                theme: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return SwipeableDrawer;
    }
}

SwipeableDrawerModel.serializers = {
    ...ReactWidgetModel.serializers,
    anchor: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
};
