import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import TableCell from '@material-ui/core/TableCell';
import { ReactWidgetModel } from './ReactWidget';

export class TableCellModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'TableCellModel',
                align: undefined,
                children: undefined,
                classes: null,
                class_name: null,
                component: null,
                padding: undefined,
                scope: null,
                size: undefined,
                sort_direction: undefined,
                variant: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return TableCell;
    }
}

TableCellModel.serializers = {
    ...ReactWidgetModel.serializers,
    align: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
    padding: { deserialize: unpack_models },
    size: { deserialize: unpack_models },
    sort_direction: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
};
