import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import TablePagination from '@material-ui/core/TablePagination';
import { ReactWidgetModel } from './ReactWidget';

export class TablePaginationModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'TablePaginationModel',
                Actions_component: null,
                back_icon_button_props: null,
                classes: null,
                col_span: null,
                component: null,
                count: null,
                label_rows_per_page: undefined,
                next_icon_button_props: null,
                page: null,
                rows_per_page: null,
                rows_per_page_options: null,
                Select_props: null,
                align: undefined,
                children: undefined,
                class_name: null,
                padding: undefined,
                scope: null,
                size: undefined,
                sort_direction: undefined,
                variant: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return TablePagination;
    }
}

TablePaginationModel.serializers = {
    ...ReactWidgetModel.serializers,
    label_rows_per_page: { deserialize: unpack_models },
    align: { deserialize: unpack_models },
    children: { deserialize: unpack_models },
    padding: { deserialize: unpack_models },
    size: { deserialize: unpack_models },
    sort_direction: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
};
