import { unpack_models } from '@jupyter-widgets/base'; // eslint-disable-line no-unused-vars
import Tabs from '@material-ui/core/Tabs';
import { ReactWidgetModel } from './ReactWidget';

export class TabsModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'TabsModel',
                centered: null,
                children: undefined,
                classes: null,
                class_name: null,
                component: null,
                indicator_color: undefined,
                Scroll_button_component: null,
                scroll_buttons: undefined,
                Tab_indicator_props: null,
                text_color: undefined,
                theme: null,
                value: undefined,
                variant: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return Tabs;
    }
}

TabsModel.serializers = {
    ...ReactWidgetModel.serializers,
    children: { deserialize: unpack_models },
    indicator_color: { deserialize: unpack_models },
    scroll_buttons: { deserialize: unpack_models },
    text_color: { deserialize: unpack_models },
    value: { deserialize: unpack_models },
    variant: { deserialize: unpack_models },
};
