import { unpack_models } from '@jupyter-widgets/base';
import SpeedDial from '@material-ui/lab/SpeedDial';
import { ReactWidgetModel } from '../generated/ReactWidget';

export class SpeedDialModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'SpeedDialModel',
                ariaLabel: null,
                Button_props: null,
                children: undefined,
                classes: null,
                class_name: null,
                direction: undefined,
                hidden: null,
                icon: undefined,
                open_: null,
                open_icon: undefined,
                Transition_component: null,
                transition_duration: null,
                Transition_props: null,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return SpeedDial;
    }
}

SpeedDialModel.serializers = {
    ...ReactWidgetModel.serializers,
    children: { deserialize: unpack_models },
    direction: { deserialize: unpack_models },
    icon: { deserialize: unpack_models },
    open_icon: { deserialize: unpack_models },
};
