import { unpack_models } from '@jupyter-widgets/base';
import SpeedDialIcon from '@material-ui/lab/SpeedDialIcon';
import { ReactWidgetModel } from '../generated/ReactWidget';

export class SpeedDialIconModel extends ReactWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            ...{
                _model_name: 'SpeedDialIconModel',
                classes: null,
                icon: undefined,
                open_: null,
                open_icon: undefined,
            },
        };
    }

    getReactComponent() { // eslint-disable-line class-methods-use-this
        return SpeedDialIcon;
    }
}

SpeedDialIconModel.serializers = {
    ...ReactWidgetModel.serializers,
    icon: { deserialize: unpack_models },
    open_icon: { deserialize: unpack_models },
};
